/*
gyjn Version 1.04
To print lines in reverse order. ( stɏo͂ )
Copyright 2015 Sogaya
Please enter "gyjn -V" for usage.

Borland C++ 5.5.1 for Win32

*/

#include "gyjn.h"

int main(int argc, char *argv[]) {
    char *p;
    char buffer[BUFFER_SIZE];
    FILE *file;
    int k;
    LINE origin;
    LINE *line = &origin;
    LINE *m;

    strcpy(line->data, "origin");
    line->number = 0;
    line->preceding = NULL;

    switch(argc) {
    case 2:
        if(! strcmp(argv[1], "-V") ) {
            guide();
            return 1;
        }

        file = fopen(argv[1], "rt");
        if(file == NULL) {
            fprintf(stderr, "%s\n", argv[1]);
            return 1;
        }

        break;
    default:
        file = stdin;
        break;
    }

/* When the user presses Ctrl + C, gyjn shows the User's Guide. */
    signal(SIGINT, signal_handler);

    for(k = 1; ; k++) {
        p = fgets(buffer, BUFFER_SIZE, file);
        if(p == NULL) {
            break;
        }

/* Preparing another LINE object */
        m = malloc( sizeof(LINE) );
        if(m == NULL) {
            fprintf(stderr, "malloc( sizeof(LINE) ) returned NULL.");
            return 1;
        }

        strcpy(m->data, buffer);
        m->number = k;
        m->preceding = line;

/* next */
        line = m;
    }

    if(line->number > 0) {
        for(;;) {
            fputs(line->data, stdout);

/* next */
            m = line;
            line = line->preceding;
            if(line->number == 0) {
                break;
            } else {
                free(m);
            }

        }

    }

    if(file != stdin) {
        fclose(file);
    }

    return 0;
}

void guide(void) {
    fprintf(stderr, "gyjn Version %1.2f \n\n", VERSION);
    fprintf(stderr, "gyjn < file > reverse_file \n");
    fprintf(stderr, "gyjn file > reverse_file \n");
    fprintf(stderr, "gyjn -V \n");
}

void signal_handler(int dummy) {
    guide();
    exit(1);
}

